/*
    TIHex v0.41
    Copyright (C) 2004 Jonas Gehring
    This programm uses functions from ExtGraph v2.00beta2 and TIChess by TIChessTeam
        
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// C Source File
// Created 08.04.04; 17:30:13

#include <tigcclib.h>					// Include all standard header files
#include "tihex.h"						// Include "tihex"-header
#include "extgraph.h"					// Include ExtGraph v2.00beta2 by TIChessTeam

// Main Function
void _main(void)
{
	int wininfo = 0;
	char win[18];

	// We can't play TIHex on a TI-89!!
	if (!CALCULATOR)
		return;
	
	// Set key autorepeat key delay to 150/395 seconds (half the standard time)
	OSInitKeyInitDelay (150);
	_startend();

	ClrScr();
	
	if (!GrayOn())
		return;
	
	gamestart:
	wininfo = _startgame();
	
	if (wininfo == EXIT)
		goto quit;	
	
	
	sprintf(win, "Player %d has won!!", wininfo);
	// Draw the 'menu' rectangle with a height of 64
	// and show 'winners screen'
	_drawrect(64);
	DrawGrayStrExt(0, 46, VERSION, A_REVERSE | A_CENTERED, SMALL);
	DrawGrayStrExt(0, 54, "by saubue", A_REVERSE | A_CENTERED, SMALL);
	DrawGrayStrExt(0, 70, win, A_REVERSE | A_CENTERED, MEDIUM);
	// Wait for keypress
	ngetchx();
	
	_clearfield();
	_redraw();
	_drawrect(40);
	DrawGrayStrExt(0, 65, "Do you want to play again?", A_REVERSE | A_CENTERED, SMALL);
	if (ngetchx() == KEY_ENTER)
	// if ENTER is pressed, start the game again
		goto gamestart;
	
	// Exit the game
	quit:
	_startend();
	ClearGrayScreen();
	GrayOff();
	// Set key autorepeat key delay to standard
	OSInitKeyInitDelay (336);
}



// Decompressing routine from ImageStudio v2.2 by Cullen Sauls
/* Decompresses an image that has been compressed with vertical RLE
 *
 * Paramenters:
 *   src = array of compressed data (pointer)
 *   dest = will become uncompressed array (pointer)
 *   size = size of decompressed data array
 *  src and dest need to be allocated before calling
 *  size needs to be initialized before calling
 *  change BYTES_PER_ROW and NUM_ROWS if needed
 */
#define SENTINEL_VALUE 0x91
#define BYTES_PER_ROW 30
#define NUM_ROWS 128

void DecompRLEVert(unsigned char *src, unsigned char *dest, int size)
{
	int i = 0, j;
	int pos = 0;
	int dcmpNum = 0;
	
	while (dcmpNum < size)
	{
		//decompress a run
		if (src[i] == SENTINEL_VALUE)
		{
			i++;
			for(j = 0; j < src[i + 1]; j++)
			{
				dest[pos] = src[i];
				pos += BYTES_PER_ROW;
				if (pos > BYTES_PER_ROW * NUM_ROWS)
				{
					pos -= BYTES_PER_ROW * NUM_ROWS;
					pos++;
				}
			}
			i++;
			dcmpNum += src[i];
		}
		else
		{
			dest[pos] = src[i];
			pos += BYTES_PER_ROW;
			if (pos > BYTES_PER_ROW * NUM_ROWS)
			{
				pos -= BYTES_PER_ROW * NUM_ROWS;
				pos++;
			}
			dcmpNum++;
		}
		i++;
	}
}

